﻿//------------------------------------------------------------------------------
// The contents of this file are subject to the Microsoft Public License (Ms-PL)
// You may obtain a copy of the License at http://psadmin.codeplex.com/license. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, 
// WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations 
// under the License.
// 
// The initial developer is Ben Foster (ben.foster@retroviz.com)
// Copyright (c) Retroviz Limited (http://www.retroviz.com).
// All Rights Reserved.
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PSAdmin.Core.Domain
{
    public class UserEvent {
        public virtual Guid Id { get; set; }
        public virtual UserBehaviour Behaviour { get; set; }
        public virtual string Username { get; set; }
        public virtual string HostName { get; set; }
        public virtual string IP { get; set; }
        public virtual DateTime DateCreated { get; set; }
        public virtual int? ScriptId { get; set; }
        public virtual string ScriptName { get; set; }
        public virtual string ScriptVariables { get; set; }
        public virtual string ScriptOutput { get; set; }
    }

    public enum UserBehaviour
    {
        ExecuteScript = 1
    }

    // raise events when scripts are run
}
