﻿//------------------------------------------------------------------------------
// The contents of this file are subject to the Microsoft Public License (Ms-PL)
// You may obtain a copy of the License at http://psadmin.codeplex.com/license. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, 
// WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations 
// under the License.
// 
// The initial developer is Ben Foster (ben.foster@retroviz.com)
// Copyright (c) Retroviz Limited (http://www.retroviz.com).
// All Rights Reserved.
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PSAdmin.Core.Domain;
using System.ComponentModel.DataAnnotations;

namespace PSAdmin.Core.Security
{
    public class UserRole : Entity<UserRole, Guid> {
        public override Guid Id { get; set; }
        [Required]
        public virtual string Name { get; set; }
        public virtual ICollection<UserRoleMapping> Users { get; set; }

        public virtual int NumberOfUsers {
            get { return this.Users.Count(); }
        }

        public virtual bool HasUsers {
            get { return this.NumberOfUsers > 0; }
        }

        public virtual string LoweredName {
            get { return Name.ToLower(); }
        }

        public UserRole() { 
			this.Users = new HashSet<UserRoleMapping>();
		}
        public UserRole(string roleName) : this() {
            this.Name = roleName;
        }
    }
}
