//------------------------------------------------------------------------------
// The contents of this file are subject to the Microsoft Public License (Ms-PL)
// You may obtain a copy of the License at http://psadmin.codeplex.com/license. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, 
// WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations 
// under the License.
// 
// The initial developer is Ben Foster (ben.foster@retroviz.com)
// Copyright (c) Retroviz Limited (http://www.retroviz.com).
// All Rights Reserved.
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using PSAdmin.Core.Interfaces;
using PSAdmin.Web.Infrastructure;

namespace PSAdmin.Web.Controllers
{
    [Authorize(Roles="Administrators")]
    public class AuditController : Controller
    {
        private IUserEventRepository _eventRepository;

        public AuditController(IUserEventRepository eventRepository) {
            _eventRepository = eventRepository;
        }
        
        //
        // GET: /Audit/

        [HttpGet]
        public ActionResult Index(int? page)
        {
            var pageIndex = page ?? 1;

            var events = _eventRepository.GetPaged(pageIndex, 10);

            return View(events);
        }
    }
}
