﻿//------------------------------------------------------------------------------
// The contents of this file are subject to the Microsoft Public License (Ms-PL)
// You may obtain a copy of the License at http://psadmin.codeplex.com/license. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, 
// WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations 
// under the License.
// 
// The initial developer is Ben Foster (ben.foster@retroviz.com)
// Copyright (c) Retroviz Limited (http://www.retroviz.com).
// All Rights Reserved.
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using PSAdmin.Core.Interfaces;

namespace PSAdmin.Web.Infrastructure
{
    public class HttpSessionStore : ISessionStore
    {
        public void Delete(string key) {
            HttpContext.Current.Session.Remove(key);
        }

        public T Get<T>(string key) {
            return (T)HttpContext.Current.Session[key];
        }

        public void Store<T>(string key, T value) {
            HttpContext.Current.Session[key] = value;
        }

        public IList<T> GetList<T>(string key) {
            throw new NotImplementedException();
        }
    }
}
