﻿//------------------------------------------------------------------------------
// The contents of this file are subject to the Microsoft Public License (Ms-PL)
// You may obtain a copy of the License at http://psadmin.codeplex.com/license. 
// 
// Software distributed under the License is distributed on an "AS IS" basis, 
// WITHOUT WARRANTY OF ANY KIND, either express or implied. 
// See the License for the specific language governing rights and limitations 
// under the License.
// 
// The initial developer is Ben Foster (ben.foster@retroviz.com)
// Copyright (c) Retroviz Limited (http://www.retroviz.com).
// All Rights Reserved.
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using PSAdmin.Core.Interfaces;

namespace PSAdmin.Web.Infrastructure
{
    public class SiteController : Controller
    {
        private ISessionStore _session;

        public SiteController(ISessionStore sessionStore) {
            _session = sessionStore;
        }

        protected string CurrentConsole {
            get { 
                string currentConsole = _session.Get<string>(SessionKeys.ConsoleSessionKey);
                if (string.IsNullOrEmpty(currentConsole)) {
                    currentConsole = string.Empty;
                    _session.Store<string>(SessionKeys.ConsoleSessionKey, currentConsole);
                }
                return currentConsole;
            }
            set { _session.Store<string>(SessionKeys.ConsoleSessionKey, value); }
        }
    }
}
